<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card v-if="selectedReport != null">
    <div>
      <h3>{{ selectedReport["topic"] }}</h3>
    </div>
    <div>
      <h4>{{ selectedReport["comment"] }}</h4>
    </div>
    <div>
      <p>
        Data utworzenia: <b>{{ showDate("date") }}</b>
      </p>
      <p>
        Status: <b>{{ statusTitle }}</b>
      </p>
      <p>
        Data pierwszego odczytania zgłoszenia:
        <b>{{ showDate("firstDate") }}</b>
      </p>
      <p>
        Użytkownik, który odczytał zgłoszenie jako pierwszy:
        <b>{{ selectedReport["firstReader"] }}</b>
      </p>
      <p v-if="checkField(selectedReport['email'])">
        Adres e-mail: <b>{{ selectedReport["email"] }}</b>
      </p>
      <p v-if="checkField(selectedReport['phone'])">
        Numer telefonu: <b>{{ selectedReport["phone"] }}</b>
      </p>
      <p v-if="checkField(selectedReport['unit'])">
        Jednostka organizacyjna: <b>{{ selectedReport["unit"] }}</b>
      </p>
      <p>
        User agent: <b>{{ selectedReport["userAgent"] }}</b>
      </p>
    </div>
  </base-card>
  <set-status
    v-if="selectedReport != null"
    :status-id="selectedReport['status']"
    :report-id="selectedReport['uuId']"
  ></set-status>
  <comments-list
    v-if="selectedReport != null"
    :comments="getComments"
    :report-id="selectedReport['uuId']"
  ></comments-list>
</template>

<script setup>
import CommentsList from "@/components/CommentsList.vue";
import SetStatus from "@/components/SetStatus.vue";
import { computed, defineProps, ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const props = defineProps(["id"]);

const error = ref(null);
const selectedReport = ref(null);

const store = useStore();
const router = useRouter();

function handleError() {
  error.value = null;
}

function checkField(field) {
  return field !== null && field !== "";
}

function showDate(field) {
  const $date = selectedReport.value[field]["date"];
  return (
    $date.substring(8, 10) +
    "-" +
    $date.substring(5, 7) +
    "-" +
    $date.substring(0, 4)
  );
}

const getComments = computed(function () {
  return selectedReport.value["comments"];
});
const statusTitle = computed(function () {
  return store.getters.reportStatutes.find(
    (report) => report["id"] === selectedReport.value["status"]
  )["status"];
});

if (
  store.getters.reports.find((report) => report["id"] === props.id) ===
  undefined
) {
  router.replace("/notFound");
} else if (
  store.getters.reports.find((report) => report["id"] === props.id)[
    "isRead"
  ] === false
) {
  router.replace("/firstRead/" + props.id);
} else {
  try {
    selectedReport.value = store.getters.reports.find(
      (report) => report["id"] === props.id
    );
  } catch (error) {
    error.value = error.message || "Nie udało się załadować danych.";
  }
}
</script>

<style scoped>
h3 {
  font-size: 1.5rem;
}

h3,
h4 {
  margin: 0.5rem 0;
}

div {
  margin: 0.5rem 0;
}
</style>
